"use strict";
exports.__esModule = true;
// return the value by doing a deeep inspection using the parts array
function deepPropValue(parts, parent) {
    for (var i = 0; i < parts.length && parent; i++) {
        parent = parent[parts[i]];
    }
    return parent;
}
exports.deepPropValue = deepPropValue;
function checkRequiredOptions(keys, options) {
    if (!options) {
        throw new Error('missing options');
    }
    keys.forEach(function (key) {
        if (typeof options[key] === 'undefined') {
            throw new Error('missing "' + key + '" options value');
        }
    });
}
exports.checkRequiredOptions = checkRequiredOptions;
function logger(prefix) {
    var pre = [prefix];
    return function () {
        /* eslint-disable no-console */
        console.log.apply(console, pre.concat.apply(pre, arguments));
        /* eslint-enable no-console */
    };
}
exports.logger = logger;
