"use strict";
exports.__esModule = true;
/**
 * Monkey patch the store.promise function to see if the action has a `promise` attribute and, if so,
 * override the standard return value of dispatch with the promise provided by the action.
 */
function default_1(store) {
    var _dispatch = store.dispatch;
    store.dispatch = function (action) {
        var rtn = _dispatch.call(store, action);
        if (action.promise) {
            return action.promise;
        }
        return rtn;
    };
}
exports["default"] = default_1;
